import { NgZone, TemplateRef } from '@angular/core';
import { Observable } from 'rxjs';
import * as THREE from 'three';
import { NgtInstance, NgtInstanceState } from './abstracts/instance';
import { Ref } from './ref';
import { NgtResizeResult } from './services/resize';
import { NgtStore } from './stores/store';
import type { AnyFunction, NgtEventManager, NgtSize } from './types';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
export declare const privateKeys: readonly ["events", "invalidate", "advance", "size", "viewport"];
export declare class NgtPortalContent {
    templateRef: TemplateRef<{
        portal: Ref<THREE.Scene>;
    }>;
    constructor(templateRef: TemplateRef<{
        portal: Ref<THREE.Scene>;
    }>);
    static ngTemplateContextGuard(dir: NgtPortalContent, ctx: any): ctx is {
        portal: Ref<THREE.Scene>;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtPortalContent, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtPortalContent, "ng-template[ngt-portal-content]", never, {}, {}, never>;
}
export interface NgtPortalState extends NgtInstanceState<THREE.Scene> {
    size: NgtSize;
    events: Pick<NgtEventManager, 'enabled' | 'priority' | 'compute' | 'connected'>;
    raycaster: THREE.Raycaster;
    pointer: THREE.Vector2;
    portalStore: NgtStore;
}
export declare class NgtPortal extends NgtInstance<THREE.Scene, NgtPortalState> {
    private resizeResult$;
    set size(size: NgtSize);
    set events(events: Pick<NgtEventManager, 'enabled' | 'priority' | 'compute' | 'connected'>);
    content?: NgtPortalContent;
    constructor(zone: NgZone, store: NgtStore, parentRef: AnyFunction<Ref>, parentHostRef: AnyFunction<Ref>, resizeResult$: Observable<NgtResizeResult>);
    ngOnInit(): void;
    private readonly init;
    private readonly initPortalStore;
    private readonly subscribeToRoot;
    private readonly setInitialPortalState;
    private inject;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtPortal, [null, { skipSelf: true; }, { optional: true; skipSelf: true; }, { optional: true; skipSelf: true; }, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgtPortal, "ngt-portal", never, { "size": "size"; "events": "events"; }, {}, ["content"], ["*"]>;
}
export declare class NgtPortalModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtPortalModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<NgtPortalModule, [typeof NgtPortal, typeof NgtPortalContent], [typeof i1.CommonModule], [typeof NgtPortal, typeof NgtPortalContent]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<NgtPortalModule>;
}
