import { NgZone } from '@angular/core';
import * as THREE from 'three';
import { NgtInstance, NgtInstanceState } from '../abstracts/instance';
import { Ref } from '../ref';
import { NgtStore } from '../stores/store';
import type { AnyConstructor, NumberInput } from '../types';
import { AnyFunction } from '../types';
import * as i0 from "@angular/core";
export declare abstract class NgtCommonTexture<TTexture extends THREE.Texture = THREE.Texture> extends NgtInstance<TTexture, NgtInstanceState<TTexture>> {
    protected document: Document;
    abstract get textureType(): AnyConstructor<TTexture>;
    set args(v: ConstructorParameters<AnyConstructor<TTexture>>);
    set image(image: HTMLImageElement | HTMLCanvasElement | HTMLVideoElement);
    set mapping(mapping: THREE.Mapping);
    set wrapS(wrapS: THREE.Wrapping);
    set wrapT(wrapT: THREE.Wrapping);
    set magFilter(magFilter: THREE.TextureFilter);
    set minFilter(minFilter: THREE.TextureFilter);
    set format(format: THREE.PixelFormat | THREE.CompressedPixelFormat);
    set type(type: THREE.TextureDataType);
    set anisotropy(anisotropy: NumberInput);
    set encoding(encoding: THREE.TextureEncoding);
    constructor(zone: NgZone, store: NgtStore, parentRef: AnyFunction<Ref>, parentHostRef: AnyFunction<Ref>, document: Document);
    ngOnInit(): void;
    private readonly init;
    protected get optionFields(): Record<string, boolean>;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgtCommonTexture<any>, [null, null, { optional: true; skipSelf: true; }, { optional: true; skipSelf: true; }, null]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgtCommonTexture<any>, never, never, { "args": "args"; "image": "image"; "mapping": "mapping"; "wrapS": "wrapS"; "wrapT": "wrapT"; "magFilter": "magFilter"; "minFilter": "minFilter"; "format": "format"; "type": "type"; "anisotropy": "anisotropy"; "encoding": "encoding"; }, {}, never>;
}
