import * as THREE from 'three';
import type { AnyConstructor, NgtColor, NgtDpr, NgtIntersection, NgtVector2, NgtVector3, NgtVector4 } from '../types';
export declare function makeVector2(input?: NgtVector2): THREE.Vector2;
export declare function makeVector3(input?: NgtVector3): THREE.Vector3;
export declare function makeVector4(input?: NgtVector4): THREE.Vector4;
export declare function make<TType extends AnyConstructor<any>>(type: TType, input?: InstanceType<TType> | Parameters<typeof type.prototype['set']> | ConstructorParameters<TType>): InstanceType<TType>;
export declare function makeColor(color?: NgtColor): THREE.Color;
export declare function makeDpr(dpr: NgtDpr): number;
/**
 * Generate a random Id or an Event's uuid
 *
 * @param {NgtIntersection} event
 *
 * @internal
 * @private
 */
export declare function makeId(event?: NgtIntersection): string;
